"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class PromiseQueue {
    concurrency;
    tasks = [];
    active = 0;
    // Don't use os.cpus().length as default as this class could be used in a browser.
    constructor(concurrency) {
        this.concurrency = concurrency;
    }
    add = (provider) => new Promise((resolve, reject) => {
        this.tasks.push({ resolve, reject, provider });
        this._start();
    });
    _start = () => {
        let t;
        if (this.active >= this.concurrency || !(t = this.tasks.shift())) {
            return;
        }
        this.active++;
        t.provider()
            .then((r) => t.resolve(r), (e) => t.reject(e))
            .finally(() => {
            this.active--;
            this._start();
        });
    };
}
exports.default = PromiseQueue;
