"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const repeatedGenerator_1 = __importDefault(require("./repeatedGenerator"));
exports.default = (it, consumers) => {
    const buffers = [];
    const fill = () => {
        const res = it.next();
        for (const buffer of buffers) {
            buffer.push(res);
        }
    };
    return [
        ...repeatedGenerator_1.default(consumers, () => {
            const buffer = [];
            buffers.push(buffer);
            return {
                next() {
                    const bufRes = buffer.shift();
                    if (bufRes) {
                        return bufRes;
                    }
                    fill();
                    return buffer.shift();
                },
            };
        }),
    ];
};
