"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const slices_1 = __importDefault(require("./slices"));
const HexString = new RegExp("^#([0-9a-f]{3}|[0-9a-f]{6})$", "i");
exports.default = (str) => {
    const match = HexString.exec(str);
    if (!match) {
        throw new SyntaxError("Invalid hex color string");
    }
    const hex = match[1];
    const short = hex.length == 3;
    const parts = slices_1.default(hex, short ? 1 : 2);
    return parts.map((d) => {
        let digit = Number.parseInt(d, 16);
        if (short) {
            digit += digit * 16;
        }
        return digit;
    });
};
