"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const arrayComparator_1 = __importDefault(require("./arrayComparator"));
const derivedComparator_1 = __importDefault(require("./derivedComparator"));
const last_1 = __importDefault(require("./last"));
const multiComparator_1 = __importDefault(require("./multiComparator"));
const nativeOrdering_1 = __importDefault(require("./nativeOrdering"));
exports.default = multiComparator_1.default(arrayComparator_1.default((a, b) => {
    if (typeof a.segment == "bigint") {
        if (typeof b.segment == "bigint") {
            return nativeOrdering_1.default(a.segment, b.segment);
        }
        return -1;
    }
    else {
        if (typeof b.segment == "string") {
            return nativeOrdering_1.default(a.segment, b.segment);
        }
        return 1;
    }
}), derivedComparator_1.default(last_1.default, (a, b) => {
    if (typeof a.tiebreaker == "bigint") {
        if (typeof b.tiebreaker == "bigint") {
            return nativeOrdering_1.default(b.tiebreaker, a.tiebreaker);
        }
        return -1;
    }
    else {
        if (typeof b.tiebreaker == "string") {
            return nativeOrdering_1.default(a.tiebreaker, b.tiebreaker);
        }
        return 1;
    }
}));
