"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertNonNegative_1 = __importDefault(require("./assertNonNegative"));
exports.default = () => {
    let pending = 0;
    let allDoneListeners = new Set();
    let errorListeners = new Set();
    return {
        on: (ev, l) => {
            switch (ev) {
                case "alldone":
                    allDoneListeners.add(l);
                    break;
                case "error":
                    errorListeners.add(l);
                    break;
                default:
                    throw new TypeError(`Unknown event: ${ev}`);
            }
        },
        off: (ev, l) => {
            switch (ev) {
                case "alldone":
                    allDoneListeners.delete(l);
                    break;
                case "error":
                    errorListeners.delete(l);
                    break;
                default:
                    throw new TypeError(`Unknown event: ${ev}`);
            }
        },
        done: () => {
            if (!assertNonNegative_1.default(--pending)) {
                allDoneListeners.forEach((l) => l());
            }
        },
        add: (count = 1) => (pending += count),
        error: (err) => errorListeners.forEach((l) => l(err)),
    };
};
