"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
function* recursiveReaddirSync(dir, filter, prefix = "") {
    for (const ent of fs_1.readdirSync(dir, { withFileTypes: true })) {
        const path = path_1.join(dir, ent.name);
        if (!filter || filter.test(path)) {
            if (ent.isDirectory()) {
                yield* recursiveReaddirSync(path, filter, prefix + ent.name + "/");
            }
            else {
                yield path_1.join(prefix + ent.name);
            }
        }
    }
}
exports.default = recursiveReaddirSync;
